# include "parm.h"

# include "stree/ststructs.mh"

# include "precedence.h"

# extern int yynerrs;
# extern int pend[];

def precedence(p) # /* return the operator precedence associated with */
  #    /* denotation p.                                  */
  # NODE * p;
  # {
  #    register unsigned stti;  /* string table index of id */
  #     register int lvl;
  if p then # added DJD
    case (p.kind)
    when BLOCKDENOTATION
      return(p.bld_precedence)
    when USELIST
      return(p.usl_precedence)
    when WORDCAND
      return(2)
    when WORDCOR
      return(1)
    when OPRID
      stti = p.id_str_table_index
      if (stti.pend[NLEVELS - 1]) then
        if((p.kind) == OPRID) then
          return(3) # /* default precedence */)
        else
          return(INFINITE)
        end
        lvl = 0
        while stti.pend[lvl] do
          lvl+=1
        end
        return(lvl)
      else
        return(INFINITE)
      end
    when LETTERID
      stti = p.id_str_table_index
      if (stti.pend[NLEVELS - 1]) then
        if((p.kind) == OPRID) then
          return(3) # /* default precedence */)
        else
          return(INFINITE)
        end
        lvl = 0
        while stti.pend[lvl] do
          lvl+=1
        end
        return(lvl)
      else
        return(INFINITE)
      end
    else # added DJD
      return(INFINITE)
    end
  end
end

