# /* Reorder type signatures, conditionals, and loops.  Reordering of   */
# /* type signatures is essential since subsequent passes assume a      */
# /* normal form.  Reordering of conditionals and loops generalizes     */
# /* signature matching and makes sure the programmer doesn't rely      */
# /* on sequential evaluation of guarded commands.  It also makes life  */
# /* easier for the code generator, since else guards will be permuted  */
# /* to the end.                                                        */
def reorder(p)
   # register int * q;   /* pointer to next field of p to be recursively     */
   #                     /* examined.                                        */
   # register int v;     /* bit vector specifying primary link fields of *p  */
   #                     /* shifted so that the most significant bit         */
   #                     /* corresponds to q.                                */
  if (p == RNIL) then 
    return
  end
  #  /* recursively examine subtrees */
  if (is_list(p)) then  # frag000022
    #    maplist(e, p, {
    #              reorder(e);
    #            });
    # 1 "in/frag000022.rb.c"
    mL__0O = ((p).lh_first); 
    while (mL__0O != RNIL) do
      e = cn_head(mL__0O)
      reorder(e)
      mL__0O = cn_tail(mL__0O) 
    end
  else 
    v = $stplinks[p.kind]
    q = p
    while ( v != 0 ) do
      if ( v < 0) then # /* msb is set */) {
        reorder(*q)
      end
      q += 1
      v <<= 1
    end
  end
  # /* Now massage the subtree in question */
  case( p.kind ) 
  when GUARDEDLIST
      gden_order(p)
  when LOOPDENOTATION
      #    /* reorder list of guarded denotations */
      gden_order(p)
    # break;
  when TYPESIGNATURE
      #    /* reorder type signature */
      tsig_order(p)
    #    break;
  end
end

#DJDSTOP
# include "parm.h"

# include "stree/ststructs.mh"

extern int stplinks[];



/* Fix up the subtree headed by p */
reorder(p)
NODE * p;
{
    register int * q;   /* pointer to next field of p to be recursively     */
                        /* examined.                                        */
    register int v;     /* bit vector specifying primary link fields of *p  */
                        /* shifted so that the most significant bit         */
                        /* corresponds to q.                                */

    if (p == NIL) return;
    /* recursively examine subtrees */
        if (is_list(p)) {
            maplist(e, p, {
                reorder(e);
            });
        } else {
            v = stplinks[p -> kind];
            q = (int *) p;
            while ( v != 0 ) {
                if ( v < 0 /* msb is set */) {
                    reorder(*q);
                }
                q++;
                v <<= 1;
            }
	}
    /* Now massage the subtree in question */
        switch( p -> kind ) {
            case GUARDEDLIST:
            case LOOPDENOTATION:
                /* reorder list of guarded denotations */
                    gden_order(p);
                break;
            case TYPESIGNATURE:
                /* reorder type signature */
                    tsig_order(p);
                break;
        }
}

#DJDSTART
