# define DEBUG

# define TRACE
# undef TRACE
# /* Fix up references to identifiers within signatures.  Note          */
# /* that by our specially contrived restrictions this can be done      */
# /* before the signature deduction phase.                              */
#
# /* This pass also fixes up the def_found                              */
# /* of identifiers explicitly selected from a type.                    */
#
# /* String expansions are added inside signatures.                     */
#
# /* fc_code_label fields are filled in.                                */
#
# /* Ap_void_decl fields are filled in.                                 */

# /* fsig_slink_known fields are set for signature of function */
# /* constructions.  They are then propagated by pass4.        */
#
# /* NO_SURR_LOOPS flags are filled in for BLOCKDENOTATIONs.   */
# /* no_surr_loop fields in MODPRIMARY's are set appropriately */


# include <stdio.h>
# include <ctype.h>
# include "parm.h"

# include "stree/ststructs.mh"

# include "../pass4/sigs.h"

# include "is_local.h"

#DJDSTOP
char * getname()

extern FILE * unparse_file
extern int stplinks[]
extern int yynerrs
extern char * entry_name

static int fn_count = 0

static boolean insig = FALSE     # /* currently looking at signature         */

static NODE * curr_void_decl = RNIL

static NODE * curr_sig_transp = RNIL
				  # /* Innermost signature transparent       */
				  # /* declaration, whose r.h.s is currently */
				  # /* being processed.                      */

static boolean in_loop = FALSE

extern NODE * var_Void

extern NODE * sig_Signature

void check_sig()       # /* Checks that an expression has the form of a */
			# /* signature.                                  */


# /* Fix up the subtree headed by p */
#DJDSTART
def sigids(p)
  #    register int * q   # /* pointer to next field of p to be recursively   */
  #                        # /* examined.                                        */
  #    register int v     # /* bit vector specifying primary link fields of *p  */
  #                        # /* shifted so that the most significant bit         */
  #                        # /* corresponds to q.                                */
  old_insig = $insig
  old_in_loop = $in_loop
  old_void_decl = $curr_void_decl
  old_sig_transp = $curr_sig_transp
  
  if (p == RNIL)  then 
    return
  end
  case ( p.kind )
  when OPRID
    $stderr.puts "sigids when 00000001\n"
    if ( p.sel_type != RNIL ) then
      p.id_last_definition = RNIL
      p.id_def_found = true
      sigids( p.sel_type)
    elsif ($insig) then
      #               ifdef TRACE
      printf("Finding declaration of %s, $curr_sig_transp = %X, def = %X\n",
             getname(p.id_str_table_index), $curr_sig_transp,
             p.id_last_definition)
      #               endif
      if (p.signature != RNIL && p.sig_done != SIG_DONE) then
        # /* user specifed signature */
        errmsg0(p,
                "Warning - signatures in signatures are ignored")
        $yynerrs-=1
      end
      if ($curr_sig_transp != RNIL &&
          p.id_last_definition != RNIL) then
        rdef = p.id_last_definition
        imid = $curr_sig_transp.decl_innermost_id
        
        # /* Update innermost id of $curr_sig_transp */
        if (rdef.kind == DECLARATION) then
          # /* Check that it's not a forward reference */
          if (rdef.post_num >= p.post_num) then
            errmsg1(p, "Forward reference to %s in === declaration",
                    getname(p.id_str_table_index))
          end
          if (rdef.decl_sig_transp) then
            id_def = rdef.decl_innermost_id
          else 
            id_def = rdef
          end
          if (id_def != RNIL &&
              (imid == RNIL ||
               is_descendant(id_def, imid.decl_scope))) then
            
            $curr_sig_transp.decl_innermost_id = id_def
            #DJDSTOP
            #                           ifdef TRACE
            #            unparse_file = stdout
            #            printf("Setting innermost id of ")
            #            unparse($curr_sig_transp.decl_id)
            #            printf(" to ")
            #            unparse(id_def.decl_id)
            #            printf("\n")
            #            #                           endif
            #            #                           ifdef DEBUG
            #            if (id_def.kind != DECLARATION) then
            #              dbgmsg("Sigids: Bad decl_innermost_id\n")
            #            end
            #            #                           endif
            #DJDSTART
          end
        end
      end
      # /* MAY NEED TO BE SMARTER EVENTUALLY */
      if (p.id_last_definition == RNIL &&
          p.id_str_table_index != -1) then
        # /* This hopefully excludes defining instances */
        usl = p.id_use_list
        #            NOADE * sig, * def
        
        while (usl != RNIL) do  # frag000030
    $stderr.puts "sigids while 00000002\n"
          #          maplist(s, usl.usl_type_list, {
          #                    if ((s.kind != LETTERID && s.kind != OPRID)
          #                        || s.signature != RNIL
          #                        || s.sel_type != RNIL) then
          #                      initfld(&(p.sel_type), s)
          #                      __goto__(:fixed_it)
          #                    else 
          #                      rdef = s.id_last_definition
          #                      if (rdef == RNIL ||
          #                          (rdef.kind != DECLARATION &&
          #                           rdef.kind != PARAMETER) ||
          #                          (rdef.kind == DECLARATION &&
          #                           rdef .decl_signature == RNIL)) then
          #                        initfld(&(p.sel_type),s)
          #                        __goto__(:fixed_it)
          #                      end
          #                      sig = (rdef.kind == PARAMETER) ?
          #                      rdef.par_signature :
          #                        rdef.decl_signature
          #                      if (sig.kind == TYPESIGNATURE &&
          #                          hascomp(sig, p.id_str_table_index)) then
          #                        initfld(&(p.sel_type), s)
          #                        __goto__(:fixed_it)
          #                      end
          #                    end
          #                  })   # end maplist I believe
          # 1 "in/frag000030.rb.c"
          mL__0O = ((usl.usl_type_list).lh_first); 
          while(mL__0O != RNIL) do
    $stderr.puts "sigids when 00000003\n"
            s = cn_head(mL__0O); 
            if ((s.kind != LETTERID && s.kind != OPRID) || s.signature != RNIL || s.sel_type != RNIL) then
              initfld(p.sel_type, s); 
              __goto__(:fixed_it_1) 
            else 
              rdef = s.id_last_definition; 
              if (rdef == RNIL || (rdef.kind != DECLARATION && rdef.kind != PARAMETER) || (rdef.kind == DECLARATION && rdef.decl_signature == RNIL)) then
                initfld(p.sel_type,s)
                __goto__(:fixed_it_1) 
              end 
              sig = (rdef.kind == PARAMETER) ? rdef.par_signature : rdef.decl_signature; 
              if (sig.kind == TYPESIGNATURE && hascomp(sig, p.id_str_table_index)) then
                initfld(p.sel_type, s); 
                __goto__(:fixed_it_1)
              end
            end                                                               
            mL__0O = cn_tail(mL__0O) 
          end
          # 27 "in/frag000030.rb.c"
          ;
          
          usl = usl.usl_previous_list
        end
        errmsg1(p,"%s undeclared",
                getname(p.id_str_table_index))
        # /* make sure the next pass doesn't run into it again */
        p.signature = ERR_SIG
        p.sig_done = SIG_DONE
        # break
      else
        __label__(:fixed_it_1)
        p.id_def_found = true
        sigids(p.sel_type)
        check_sig(p.signature)
        sigids( p.signature )
      end
    end
  when LETTERID
    $stderr.puts "sigids when 00000004\n"
    if ( p.sel_type != RNIL ) then
      p.id_last_definition = RNIL
      p.id_def_found = true
      sigids( p.sel_type)
       elsif ($insig) then
      #               ifdef TRACE
      printf("Finding declaration of %s, $curr_sig_transp = %X, def = %X\n",
             getname(p.id_str_table_index), $curr_sig_transp,
             p.id_last_definition)
      #               endif
      if (p.signature != RNIL && p.sig_done != SIG_DONE) then
        # /* user specifed signature */
        errmsg0(p,
                "Warning - signatures in signatures are ignored")
        $yynerrs-=1
      end
      if ($curr_sig_transp != RNIL &&
          p.id_last_definition != RNIL) then
        rdef = p.id_last_definition
        imid = $curr_sig_transp.decl_innermost_id
        
        # /* Update innermost id of $curr_sig_transp */
        if (rdef.kind == DECLARATION) then
          # /* Check that it's not a forward reference */
          if (rdef.post_num >= p.post_num) then
            errmsg1(p, "Forward reference to %s in === declaration",
                    getname(p.id_str_table_index))
          end
          if (rdef.decl_sig_transp) then
            id_def = rdef.decl_innermost_id
          else 
            id_def = rdef
          end
          if (id_def != RNIL &&
              (imid == RNIL ||
               is_descendant(id_def, imid.decl_scope))) then
            
            $curr_sig_transp.decl_innermost_id = id_def
            #DJDSTOP
            #                           ifdef TRACE
            #            unparse_file = stdout
            #            printf("Setting innermost id of ")
            #            unparse($curr_sig_transp.decl_id)
            #            printf(" to ")
            #            unparse(id_def.decl_id)
            #            printf("\n")
            #            #                           endif
            #            #                           ifdef DEBUG
            #            if (id_def.kind != DECLARATION) then
            #              dbgmsg("Sigids: Bad decl_innermost_id\n")
            #            end
            #            #                           endif
            #DJDSTART
          end
        end
      end
      # /* MAY NEED TO BE SMARTER EVENTUALLY */
      if (p.id_last_definition == RNIL &&
          p.id_str_table_index != -1) then
        # /* This hopefully excludes defining instances */
        usl = p.id_use_list
        #            NOADE * sig, * def
        
        while (usl != RNIL) do  # frag000030
    $stderr.puts "sigids when 00000005\n"
          #          maplist(s, usl.usl_type_list, {
          #                    if ((s.kind != LETTERID && s.kind != OPRID)
          #                        || s.signature != RNIL
          #                        || s.sel_type != RNIL) then
          #                      initfld(&(p.sel_type), s)
          #                      __goto__(:fixed_it)
          #                    else 
          #                      rdef = s.id_last_definition
          #                      if (rdef == RNIL ||
          #                          (rdef.kind != DECLARATION &&
          #                           rdef.kind != PARAMETER) ||
          #                          (rdef.kind == DECLARATION &&
          #                           rdef .decl_signature == RNIL)) then
          #                        initfld(&(p.sel_type),s)
          #                        __goto__(:fixed_it)
          #                      end
          #                      sig = (rdef.kind == PARAMETER) ?
          #                      rdef.par_signature :
          #                        rdef.decl_signature
          #                      if (sig.kind == TYPESIGNATURE &&
          #                          hascomp(sig, p.id_str_table_index)) then
          #                        initfld(&(p.sel_type), s)
          #                        __goto__(:fixed_it)
          #                      end
          #                    end
          #                  })   # end maplist I believe
          # 1 "in/frag000030.rb.c"
          mL__0O = ((usl.usl_type_list).lh_first); 
          while(mL__0O != RNIL) do
    $stderr.puts "sigids when 00000006\n"
            s = cn_head(mL__0O); 
            if ((s.kind != LETTERID && s.kind != OPRID) || s.signature != RNIL || s.sel_type != RNIL) then
              initfld(p.sel_type, s); 
              __goto__(:fixed_it_2)
            else 
              rdef = s.id_last_definition; 
              if (rdef == RNIL || (rdef.kind != DECLARATION && rdef.kind != PARAMETER) || (rdef.kind == DECLARATION && rdef.decl_signature == RNIL)) then
                initfld(p.sel_type,s)
                __goto__(:fixed_it_2) 
              end 
              sig = (rdef.kind == PARAMETER) ? rdef.par_signature : rdef.decl_signature; 
              if (sig.kind == TYPESIGNATURE && hascomp(sig, p.id_str_table_index)) then
                initfld(p.sel_type, s); 
                __goto__(:fixed_it_2)
              end
            end                                                               
            mL__0O = cn_tail(mL__0O) 
          end
          # 27 "in/frag000030.rb.c"
          ;
          
          usl = usl.usl_previous_list
        end
        errmsg1(p,"%s undeclared",
                getname(p.id_str_table_index))
        # /* make sure the next pass doesn't run into it again */
        p.signature = ERR_SIG
        p.sig_done = SIG_DONE
        # break
      else
        __label__(:fixed_it_2)
        p.id_def_found = true
        sigids(p.sel_type)
        check_sig(p.signature)
        sigids( p.signature )
      end
    end
    # break
    
  when QSTR
    $stderr.puts "sigids when 00000007\n"
    if ( p.sel_type != RNIL ) then
      sigids( p.sel_type)
      initfld(p.str_expansion, expand_str(p))
    elsif ($insig) then
      # /* MAY NEED TO BE SMARTER EVENTUALLY */
      usl = p.str_use_list
      #		NODE * sig, * def
      while (usl != RNIL) do # frag000031
    $stderr.puts "sigids when 00000008\n"
        #        maplist(s, usl.usl_type_list, {
        #                  if ((s.kind != LETTERID && s.kind != OPRID)
        #                      || s.signature != RNIL
        #                      || s.sel_type != RNIL) {
        #                      initfld(&(p.sel_type), s)
        #                      __goto__(:str_fixed_it)
        #                    } else {
        #                      def = s.id_last_definition
        #                        if (def == RNIL ||
        #				(def.kind != DECLARATION &&
        #                                     def.kind != PARAMETER) ||
        #                                       (def.kind == DECLARATION &&
        #                                            def .decl_signature == RNIL)) {
        #                                              initfld(&(p.sel_type),s)
        #                                              __goto__(:str_fixed_it)
        #                                            }
        #                                            sig = (def.kind == PARAMETER) ?
        #                                                   def.par_signature :
        #                                                       def.decl_signature
        #                                                         if (sig.kind == TYPESIGNATURE &&
        #                                                             hasstring(sig, p)) {
        #                                                             initfld(&(p.sel_type), s)
        #                                                             __goto__(:str_fixed_it)
        #                                                           }
        #                                                         }
        #                                                       })
        # 1 "in/frag000031.rb.c"
        mL__0O = ((usl.usl_type_list).lh_first)
        while (mL__0O != RNIL) do 
    $stderr.puts "sigids when 00000009\n"
          s = cn_head(mL__0O) 
          if ((s.kind != LETTERID && s.kind != OPRID) || s.signature != RNIL || s.sel_type != RNIL) then 
            initfld(p.sel_type, s) 
            __goto__(:str_fixed_it_1)
          else 
            rdef = s.id_last_definition
            if (rdef == RNIL || (rdef.kind != DECLARATION && rdef.kind != PARAMETER) || (rdef.kind == DECLARATION && rdef.decl_signature == RNIL)) then 
              initfld(p.sel_type,s)
              __goto__(:str_fixed_it_1)
            end
            sig = (rdef.kind == PARAMETER) ? rdef.par_signature : rdef.decl_signature
            if (sig.kind == TYPESIGNATURE && hasstring(sig, p)) then 
              initfld(p.sel_type, s) 
              __goto__(:str_fixed_it_1)
            end
          end
          mL__0O = cn_tail(mL__0O)        
        end
        # 27 "in/frag000031.rb.c"
        
        
        usl = usl.usl_previous_list
      end
      # /* no suitable type for the implied selection was found */
      case (p.kind) 
      when QSTR
    $stderr.puts "sigids when 00000010\n"
        errmsg1(p, "No appropriate type for \"%s\" inside signature",
                p.str_string)
        # break
      when UQSTR
    $stderr.puts "sigids when 00000011\n"
        errmsg1(p, "No appropriate type for %s inside signature",
                p.str_string)
        # break
      end
      p.signature = ERR_SIG
      p.sig_done = SIG_DONE
      # break
      __goto__(:str_fixed_it_skip_1)
      __label__(:str_fixed_it_1)
      initfld(p.str_expansion, expand_str(p))
      __label__(:str_fixed_it_skip_1)
    end
  when UQSTR
    $stderr.puts "sigids when 00000012\n"
    if ( p.sel_type != RNIL ) then
      sigids( p.sel_type)
      initfld(p.str_expansion, expand_str(p))
    elsif ($insig) then
      # /* MAY NEED TO BE SMARTER EVENTUALLY */
      usl = p.str_use_list
      #		NODE * sig, * def
      while (usl != RNIL) do # frag000031
    $stderr.puts "sigids when 00000013\n"
        #        maplist(s, usl.usl_type_list, {
        #                  if ((s.kind != LETTERID && s.kind != OPRID)
        #                      || s.signature != RNIL
        #                      || s.sel_type != RNIL) {
        #                      initfld(&(p.sel_type), s)
        #                      __goto__(:str_fixed_it)
        #                    } else {
        #                      def = s.id_last_definition
        #                        if (def == RNIL ||
        #				(def.kind != DECLARATION &&
        #                                     def.kind != PARAMETER) ||
        #                                       (def.kind == DECLARATION &&
        #                                            def .decl_signature == RNIL)) {
        #                                              initfld(&(p.sel_type),s)
        #                                              __goto__(:str_fixed_it)
        #                                            }
        #                                            sig = (def.kind == PARAMETER) ?
        #                                                   def.par_signature :
        #                                                       def.decl_signature
        #                                                         if (sig.kind == TYPESIGNATURE &&
        #                                                             hasstring(sig, p)) {
        #                                                             initfld(&(p.sel_type), s)
        #                                                             __goto__(:str_fixed_it)
        #                                                           }
        #                                                         }
        #                                                       })
        # 1 "in/frag000031.rb.c"
        mL__0O = ((usl.usl_type_list).lh_first)
        while (mL__0O != RNIL) do 
    $stderr.puts "sigids when 00000014\n"
          s = cn_head(mL__0O) 
          if ((s.kind != LETTERID && s.kind != OPRID) || s.signature != RNIL || s.sel_type != RNIL) then 
            initfld(p.sel_type, s) 
            __goto__(:str_fixed_it_2)
          else 
            rdef = s.id_last_definition
            if (rdef == RNIL || (rdef.kind != DECLARATION && rdef.kind != PARAMETER) || (rdef.kind == DECLARATION && rdef.decl_signature == RNIL)) then 
              initfld(p.sel_type,s)
              __goto__(:str_fixed_it_2)
            end
            sig = (rdef.kind == PARAMETER) ? rdef.par_signature : rdef.decl_signature
            if (sig.kind == TYPESIGNATURE && hasstring(sig, p)) then 
              initfld(p.sel_type, s) 
              __goto__(:str_fixed_it_2)
            end
          end
          mL__0O = cn_tail(mL__0O)        
        end
        # 27 "in/frag000031.rb.c"
        
        
        usl = usl.usl_previous_list
      end
      # /* no suitable type for the implied selection was found */
      case (p.kind) 
      when QSTR
    $stderr.puts "sigids when 00000015\n"
        errmsg1(p, "No appropriate type for \"%s\" inside signature",
                p.str_string)
        # break
      when UQSTR
    $stderr.puts "sigids when 00000016\n"
        errmsg1(p, "No appropriate type for %s inside signature",
                p.str_string)
        # break
      end
      p.signature = ERR_SIG
      p.sig_done = SIG_DONE
      # break
      __goto__(:str_fixed_it_skip_2)
      __label__(:str_fixed_it_2)
      initfld(p.str_expansion, expand_str(p))
      __label__(:str_fixed_it_skip_2)
    end
    # break
    
  when RECORDCONSTRUCTION # frag000032
    $stderr.puts "sigids when 00000017\n"
    #                maplist(s, p.rec_component_list, {
    #		    sigids(s.re_denotation)
    #		})
    # 1 "in/frag000032.rb.c"
    mL__0O = (p.rec_component_list.lh_first)
    while(mL__0O != RNIL) do
    $stderr.puts "sigids when 00000018\n"
      s = cn_head(mL__0O)
      sigids(s.re_denotation)
      mL__0O = cn_tail(mL__0O) 
    end
    #    
  when FUNCCONSTR
    $stderr.puts "sigids when 00000019\n"
    # /* give it a reasonable name */
    if (p.fc_code_label == RNIL) then
      #               define FN_LN_LEN 16
      #                char * fn_name =
      #                  (char *) malloc(strlen(entry_name)+FN_LN_LEN);
        fn_name = entry_name # DJD ????
        
      findvl(p.vlineno)
      # sprintf(fn_name,"fn_%s.ln%d_%d",entry_name,getrl(),fn_count++)
      p.fc_code_label = fn_name
    end
    $in_loop = false
    # /* look for var Void parameters, check that par. sigs are legit. */  # frag000033
    #		maplist(s, p.signature.fsig_param_list, {
    #		    check_sig(s.par_signature)
    #		    if (comp_st(s.par_signature,
    #				var_Void, RNIL, RNIL) == 0) {
    #                        $curr_void_decl = s
    #                    }
    #		})
    # 1 "in/frag000033.rb.c"
    mL__0O = (p.signature.fsig_param_list.lh_first); 
    while (mL__0O != RNIL) do
    $stderr.puts "sigids when 00000020\n"
      s = cn_head(mL__0O) 
      check_sig(s.par_signature) 
      if (comp_st(s.par_signature, var_Void, RNIL, RNIL) == 0)  then 
        $curr_void_decl = s 
      end 
      mL__0O = cn_tail(mL__0O) 
    end 
    $insig = true  # frag000034
    #		maplist(s, p.signature.fsig_param_list, {
    #		    sigids(s.par_signature)
    #		})
    # 1 "in/frag000034.rb.c"
    # 1 "<command-line>"
    # 1 "/usr/include/stdc-predef.h" 1 3 4
    # 1 "<command-line>" 2
    # 1 "in/frag000034.rb.c"
    # 1 "in/../inc/ststructs.mh" 1
    # 2 "in/frag000034.rb.c" 2
    mL__0O = (p.signature.fsig_param_list.lh_first); 
    while (mL__0O != RNIL)
    $stderr.puts "sigids when 00000021\n"
      s = cn_head(mL__0O)
      check_sig(s.par_signature) 
      if (comp_st(s.par_signature, var_Void, RNIL, RNIL) == 0) then 
        $curr_void_decl = s
      end
      mL__0O = cn_tail(mL__0O) 
    end
    check_sig(p.signature.fsig_result_sig)
    sigids(p.signature.fsig_result_sig)
    $insig = old_insig
    sigids(p.fc_body)
    p.signature.fsig_slink_known = true
    # /* static link is available in this context  */
    # /* will be cleared if function is used in    */
    # /* a context in which it's not available.    */
    # break
    
  when APPLICATION
    $stderr.puts "sigids when 00000022\n"
    sigids(p.ap_operator)
    sigids(p.ap_args)
    p.ap_void_decl = $curr_void_decl
    # break
    
  when BLOCKDENOTATION
    $stderr.puts "sigids when 00000023\n"
    if (!$in_loop) then
      p.bld_flags |= NO_SURR_LOOP
    end
    sigids(p.bld_declaration_list)
    sigids(p.bld_den_seq)
    # break
    
  when DECLARATION
    $stderr.puts "sigids when 00000024\n"
    if (p.decl_denotation.kind == FUNCCONSTR &&
        p.decl_id.kind == LETTERID &&
        p.decl_denotation.fc_code_label == RNIL) then
      # /* try to give it a reasonable name */
      #               define FN_NAME_LEN 10
      char * id_name = getname(p.decl_id.id_str_table_index)
      if (id_name[0] != '\'') then
        # char * fn_name =   # DJD ATTN
        #  (char *) malloc(strlen(id_name)
        #                  +strlen(entry_name)+FN_NAME_LEN)
        # sprintf(fn_name,"fn_%s.%s_%d",entry_name,id_name,fn_count++)
        p.decl_denotation.fc_code_label = fn_name
      end
    end
    $insig = true 
    check_sig(p.decl_signature)
    sigids(p.decl_signature)
    if (!p.decl_sig_transp) then
      $insig = old_insig
    else 
      # /* Otherwise treat the denotation as a signature */
      $curr_sig_transp = p
    end
    sigids(p.decl_denotation)
    # break
    
  when TSCOMPONENT
    $stderr.puts "sigids when 00000025\n"
    check_sig(p.tsc_signature)
    sigids(p.tsc_signature)
    # /* skip tsc_id */
    # break
    
  when EXPORTELEMENT
    $stderr.puts "sigids when 00000026\n"
    sigids(p.ee_export_list)
    $insig = true
    check_sig(p.ee_signature)
    sigids(p.ee_signature)
    # break
    
  when REXTERNDEF
    $stderr.puts "sigids when 00000027\n"
    # /* Don't bother with the signature */
    # break
    
  when PARAMETER
    $stderr.puts "sigids when 00000028\n"
    $insig = true
    check_sig(p.par_signature)
    sigids(p.par_signature)
    # /* skip par_id */
    # break
    
  when LOOPDENOTATION
    $stderr.puts "sigids when 00000029\n"
    $in_loop = true
    __goto__ (:dflt_1)
    
  when MODPRIMARY
    $stderr.puts "sigids when 00000030\n"
    p.mp_no_surr_loop = !$in_loop
    __goto__ (:dflt_1)
    
  when TYPESIGNATURE
    $stderr.puts "sigids when 00000031\n"
    $insig = true
    __label__(:dflt_1)
    # /* recursively examine subtrees */
    if (is_list(p)) then  # frag000035
      #                    maplist(e, p, {
      #                        sigids(e)
      #                    })
      # 1 "in/frag000035.rb.c"
      mL__0O = (p.lh_first)
      while (mL__0O != RNIL) do
    $stderr.puts "sigids when 00000032\n"
        e = cn_head(mL__0O)
        sigids(e) 
        mL__0O = cn_tail(mL__0O) 
      end
    else 
      v = $stplinks[p.kind]
      q =  p
      while ( v != 0 ) do
    $stderr.puts "sigids when 00000033\n"
          if ( v < 0 ) then # /* msb is set */) {
            sigids(*q)
          end
        q+=1
          v <<= 1
      end
    end
  when FUNCSIGNATURE
    $stderr.puts "sigids when 000000034\n"
    $insig = true
    __label__(:dflt_2)
    # /* recursively examine subtrees */
    if (is_list(p)) then  # frag000035
      #                    maplist(e, p, {
      #                        sigids(e)
      #                    })
      # 1 "in/frag000035.rb.c"
      mL__0O = (p.lh_first)
      while (mL__0O != RNIL) do
    $stderr.puts "sigids when 00000035\n"
        e = cn_head(mL__0O)
        sigids(e) 
        mL__0O = cn_tail(mL__0O) 
      end
    else 
      v = $stplinks[p.kind]
      q =  p
      while ( v != 0 ) do
    $stderr.puts "sigids when 00000036\n"
          if ( v < 0 ) then # /* msb is set */) {
            sigids(*q)
          end
        q+=1
          v <<= 1
      end
    end
  when VALSIGNATURE
    $stderr.puts "sigids when 00000037\n"
    $insig = true
    __label__(:dflt_3)
    # /* recursively examine subtrees */
    if (is_list(p)) then  # frag000035
      #                    maplist(e, p, {
      #                        sigids(e)
      #                    })
      # 1 "in/frag000035.rb.c"
      mL__0O = (p.lh_first)
      while (mL__0O != RNIL) do
    $stderr.puts "sigids when 00000038\n"
        e = cn_head(mL__0O)
        sigids(e) 
        mL__0O = cn_tail(mL__0O) 
      end
    else 
      v = $stplinks[p.kind]
      q =  p
      while ( v != 0 ) do
    $stderr.puts "sigids when 00000039\n"
          if ( v < 0 ) then # /* msb is set */) {
            sigids(*q)
          end
        q+=1
          v <<= 1
      end
    end
  when VARSIGNATURE
    $stderr.puts "sigids when 00000040\n"
    $insig = true
    __label__(:dflt_4)
    # /* recursively examine subtrees */
    if (is_list(p)) then  # frag000035
      #                    maplist(e, p, {
      #                        sigids(e)
      #                    })
      # 1 "in/frag000035.rb.c"
      mL__0O = (p.lh_first)
      while (mL__0O != RNIL) do
    $stderr.puts "sigids when 00000041\n"
        e = cn_head(mL__0O)
        sigids(e) 
        mL__0O = cn_tail(mL__0O) 
      end
    else 
      v = $stplinks[p.kind]
      q =  p
      while ( v != 0 ) do
    $stderr.puts "sigids when 00000042\n"
          if ( v < 0 ) then # /* msb is set */) {
            sigids(*q)
          end
        q+=1
          v <<= 1
      end
    end
    # /* and now fix up subtrees */
    
  else
    __label__(:dflt_5)
    # /* recursively examine subtrees */
    if (is_list(p)) then  # frag000035
      #                    maplist(e, p, {
      #                        sigids(e)
      #                    })
      # 1 "in/frag000035.rb.c"
      mL__0O = (p.lh_first)
      while (mL__0O != RNIL) do
    $stderr.puts "sigids when 00000043\n"
        e = cn_head(mL__0O)
        sigids(e) 
        mL__0O = cn_tail(mL__0O) 
      end
    else 
      v = $stplinks[p.kind]
      q =  p
      while ( v != 0 ) do
    $stderr.puts "sigids when 00000044\n"
          if ( v < 0 ) then # /* msb is set */) {
            sigids(*q)
          end
        q+=1
          v <<= 1
      end
    end
  end
  $insig = old_insig
  $curr_void_decl = old_void_decl
  $curr_sig_transp = old_sig_transp
end

# /* Check whether q is an explicit signature node, or an identifier bound, */
# /* via signature transparent declarations, to a signature.                */
def check_sig(q)
  p = q
  
  if (p == RNIL) then
    return
  end
  while (   (p.kind == LETTERID || p.kind == OPRID) &&
            p.sel_type == RNIL && 
            p.id_last_definition != RNIL &&
            p.id_last_definition.kind == DECLARATION &&
            p.id_last_definition.decl_sig_transp &&
            p.id_last_definition.post_num < p.post_num) do
    $stderr.puts "sigids when 00000045\n"
      p = p.id_last_definition.decl_denotation
    end
    case (p.kind)
    when SIGNATURESIG
    $stderr.puts "sigids when 00000046\n"
    when VALSIGNATURE 
    $stderr.puts "sigids when 00000047\n"
    when VARSIGNATURE
    $stderr.puts "sigids when 00000048\n"
    when FUNCSIGNATURE
    $stderr.puts "sigids when 00000049\n"
    when TYPESIGNATURE
    $stderr.puts "sigids when 00000050\n"
      #    break
    else
    $stderr.puts "sigids when 00000001\n"
      if (p.kind == LETTERID || p.kind == OPRID) then
        if ( p.id_last_definition == RNIL || 
             p.id_last_definition.kind != PARAMETER ||
             comp_st(p.id_last_definition.par_signature,
                     sig_Signature, RNIL, RNIL) != 0) then
          errmsg1(q,
                  "Identifier %s not meaningfully bound to a signature",
                  getname(q.id_str_table_index))
        end
      else 
        errmsg0(q, "Signature expected")
      end
    end
  end
  
  


#DJDSTOP
char * getname();

extern FILE * unparse_file;
extern int stplinks[];
extern int yynerrs;
extern char * entry_name;

static int fn_count = 0;

static boolean insig = FALSE;     /* currently looking at signature         */

static NODE * curr_void_decl = NIL;

static NODE * curr_sig_transp = NIL;
				  /* Innermost signature transparent       */
				  /* declaration, whose r.h.s is currently */
				  /* being processed.                      */

static boolean in_loop = FALSE;

extern NODE * var_Void;

extern NODE * sig_Signature;

void check_sig();       /* Checks that an expression has the form of a */
			/* signature.                                  */


/* Fix up the subtree headed by p */
sigids(p)
NODE * p;
{
    register int * q;   /* pointer to next field of p to be recursively     */
                        /* examined.                                        */
    register int v;     /* bit vector specifying primary link fields of *p  */
                        /* shifted so that the most significant bit         */
                        /* corresponds to q.                                */
    boolean old_insig = insig;
    boolean old_in_loop = in_loop;
    NODE * old_void_decl = curr_void_decl;
    NODE * old_sig_transp = curr_sig_transp;

    if (p == NIL) return;
    switch( p -> kind ) {
        case OPRID:
        case LETTERID:
            if ( p -> sel_type != NIL ) {
		p -> id_last_definition = NIL;
		p -> id_def_found = TRUE;
		sigids( p -> sel_type);
	    } else if (insig) {
#               ifdef TRACE
		    printf("Finding declaration of %s, curr_sig_transp = %X, def = %X\n",
			   getname(p -> id_str_table_index), curr_sig_transp,
			   p -> id_last_definition);
#               endif
		if (p -> signature != NIL && p -> sig_done != SIG_DONE) {
		    /* user specifed signature */
		    errmsg0(p,
			    "Warning - signatures in signatures are ignored");
		    yynerrs--;
		}
		if (curr_sig_transp != NIL
		    && p -> id_last_definition != NIL) {
		    NODE * def = p -> id_last_definition;
		    NODE * imid = curr_sig_transp -> decl_innermost_id;

		    /* Update innermost id of curr_sig_transp */
		      if (def -> kind == DECLARATION) {
			NODE * id_def;

			/* Check that it's not a forward reference */
			  if (def -> post_num >= p -> post_num) {
			    errmsg1(p, "Forward reference to %s in === declaration",
				    getname(p -> id_str_table_index));
			  }
			if (def -> decl_sig_transp) {
			    id_def = def -> decl_innermost_id;
			} else {
			    id_def = def;
			}
			if (id_def != NIL &&
			    (imid == NIL
			     || is_descendant(id_def, imid -> decl_scope))) {
			    curr_sig_transp -> decl_innermost_id = id_def;
#                           ifdef TRACE
				unparse_file = stdout;
				printf("Setting innermost id of ");
				unparse(curr_sig_transp -> decl_id);
				printf(" to ");
				unparse(id_def -> decl_id);
				printf("\n");
#                           endif
#                           ifdef DEBUG
				if (id_def -> kind != DECLARATION) {
				    dbgmsg("Sigids: Bad decl_innermost_id\n");
				}
#                           endif
			}
		      }
		}
		/* MAY NEED TO BE SMARTER EVENTUALLY */
		if (p -> id_last_definition == NIL
		    && p -> id_str_table_index != -1) {
		    /* This hopefully excludes defining instances */
		    NODE * usl = p -> id_use_list;
		    NODE * sig, * def;

		    while (usl != NIL) {
			maplist(s, usl -> usl_type_list, {
			    if ((s -> kind != LETTERID && s -> kind != OPRID)
			     || s -> signature != NIL
			     || s -> sel_type != NIL) {
				initfld(&(p -> sel_type), s);
				goto fixed_it;
			    } else {
				def = s -> id_last_definition;
				if (def == NIL ||
				    (def -> kind != DECLARATION &&
				    def -> kind != PARAMETER) ||
				    (def -> kind == DECLARATION &&
				    def ->decl_signature == NIL)) {
				    initfld(&(p -> sel_type),s);
				    goto fixed_it;
				}
				sig = (def -> kind == PARAMETER) ?
				      def -> par_signature :
				      def -> decl_signature;
				if (sig -> kind == TYPESIGNATURE &&
				    hascomp(sig, p -> id_str_table_index)) {
				    initfld(&(p -> sel_type), s);
				    goto fixed_it;
				}
			    }
			});
			usl = usl -> usl_previous_list;
		    }
		    errmsg1(p,"%s undeclared",
			getname(p -> id_str_table_index));
		    /* make sure the next pass doesn't run into it again */
			p -> signature = ERR_SIG;
			p -> sig_done = SIG_DONE;
		    break;
		}
		fixed_it:
		    p -> id_def_found = TRUE;
		    sigids(p -> sel_type);
	    }
	    check_sig(p -> signature);
            sigids( p -> signature );
	    break;

	case QSTR:
	case UQSTR:
            if ( p -> sel_type != NIL ) {
		sigids( p -> sel_type);
		initfld(&(p -> str_expansion), expand_str(p));
	    } else if (insig) {
		/* MAY NEED TO BE SMARTER EVENTUALLY */
		NODE * usl = p -> str_use_list;
		NODE * sig, * def;

		while (usl != NIL) {
		    maplist(s, usl -> usl_type_list, {
			if ((s -> kind != LETTERID && s -> kind != OPRID)
			     || s -> signature != NIL
			     || s -> sel_type != NIL) {
			    initfld(&(p -> sel_type), s);
			    goto str_fixed_it;
			} else {
			    def = s -> id_last_definition;
			    if (def == NIL ||
				(def -> kind != DECLARATION &&
				 def -> kind != PARAMETER) ||
				(def -> kind == DECLARATION &&
				 def ->decl_signature == NIL)) {
				initfld(&(p -> sel_type),s);
				goto str_fixed_it;
			    }
			    sig = (def -> kind == PARAMETER) ?
				  def -> par_signature :
				  def -> decl_signature;
			    if (sig -> kind == TYPESIGNATURE &&
				hasstring(sig, p)) {
				initfld(&(p -> sel_type), s);
				goto str_fixed_it;
			    }
			}
		    });
		    usl = usl -> usl_previous_list;
		}
		/* no suitable type for the implied selection was found */
		switch(p -> kind) {
		    case QSTR:
			errmsg1(p, "No appropriate type for \"%s\" inside signature",
				p -> str_string);
			break;
		    case UQSTR:
			errmsg1(p, "No appropriate type for %s inside signature",
				p -> str_string);
			break;
		}
		p -> signature = ERR_SIG;
		p -> sig_done = SIG_DONE;
		break;
	    str_fixed_it:
		initfld(&(p -> str_expansion), expand_str(p));
            }
	    break;

	case RECORDCONSTRUCTION:
                maplist(s, p -> rec_component_list, {
		    sigids(s -> re_denotation);
		});
	    break;

	case FUNCCONSTR:
            /* give it a reasonable name */
              if (p -> fc_code_label == NIL) {
#               define FN_LN_LEN 16
                char * fn_name =
                  (char *) malloc(strlen(entry_name)+FN_LN_LEN);

                findvl(p -> vlineno)
      		sprintf(fn_name,"fn_%s.ln%d_%d",entry_name,getrl(),fn_count++);
                p -> fc_code_label = fn_name;
	      }
	    in_loop = FALSE;
	    /* look for var Void parameters, check that par. sigs are legit. */
		maplist(s, p -> signature -> fsig_param_list, {
		    check_sig(s -> par_signature);
		    if (comp_st(s -> par_signature,
				var_Void, NIL, NIL) == 0) {
                        curr_void_decl = s;
                    }
		});
		insig = TRUE;
		maplist(s, p -> signature -> fsig_param_list, {
		    sigids(s -> par_signature);
		});
		check_sig(p -> signature -> fsig_result_sig);
		sigids(p -> signature -> fsig_result_sig);
		insig = old_insig;
		sigids(p -> fc_body);
		p -> signature -> fsig_slink_known = TRUE;
		    /* static link is available in this context  */
		    /* will be cleared if function is used in    */
		    /* a context in which it's not available.    */
	    break;

	case APPLICATION:
            sigids(p -> ap_operator);
	    sigids(p -> ap_args);
	    p -> ap_void_decl = curr_void_decl;
	    break;

	case BLOCKDENOTATION:
	    if (!in_loop) {
		p -> bld_flags |= NO_SURR_LOOP;
	    }
	    sigids(p -> bld_declaration_list);
	    sigids(p -> bld_den_seq);
	    break;

	case DECLARATION:
            if (p -> decl_denotation -> kind == FUNCCONSTR
		&& p -> decl_id -> kind == LETTERID
		&& p -> decl_denotation -> fc_code_label == NIL) {
	      /* try to give it a reasonable name */
#               define FN_NAME_LEN 10
		char * id_name = getname(p -> decl_id -> id_str_table_index);
		if (id_name[0] != '\'') {
		  char * fn_name =
		    (char *) malloc(strlen(id_name)
				    +strlen(entry_name)+FN_NAME_LEN);
		  sprintf(fn_name,"fn_%s.%s_%d",entry_name,id_name,fn_count++);
		  p -> decl_denotation -> fc_code_label = fn_name;
		}
	    }
	    insig = TRUE; 
	    check_sig(p -> decl_signature);
	    sigids(p -> decl_signature);
	    if (!p -> decl_sig_transp) {
		insig = old_insig;
	    } else {
		/* Otherwise treat the denotation as a signature */
		curr_sig_transp = p;
	    }
	    sigids(p -> decl_denotation);
            break;

	case TSCOMPONENT:
	    check_sig(p -> tsc_signature);
            sigids(p -> tsc_signature);
            /* skip tsc_id */
	    break;

	case EXPORTELEMENT:
	    sigids(p -> ee_export_list);
	    insig = TRUE;
	    check_sig(p -> ee_signature);
	    sigids(p -> ee_signature);
	    break;

	case REXTERNDEF:
	    /* Don't bother with the signature */
	    break;

	case PARAMETER:
	    insig = TRUE;
	    check_sig(p -> par_signature);
            sigids(p -> par_signature);
            /* skip par_id */
	    break;

	case LOOPDENOTATION:
	    in_loop = TRUE;
	    goto dflt;
	    
	case MODPRIMARY:
	    p -> mp_no_surr_loop = !in_loop;
	    goto dflt;

	case TYPESIGNATURE:
	case FUNCSIGNATURE:
	case VALSIGNATURE:
	case VARSIGNATURE:
            insig = TRUE;
            /* and now fix up subtrees */

	default:
	dflt:
            /* recursively examine subtrees */
                if (is_list(p)) {
                    maplist(e, p, {
                        sigids(e);
                    });
                } else {
                    v = stplinks[p -> kind];
                    q = (int *) p;
                    while ( v != 0 ) {
                        if ( v < 0 /* msb is set */) {
                            sigids(*q);
                        }
                        q++;
                        v <<= 1;
                    }
                }
    }
    insig = old_insig;
    curr_void_decl = old_void_decl;
    curr_sig_transp = old_sig_transp;
}

/* Check whether q is an explicit signature node, or an identifier bound, */
/* via signature transparent declarations, to a signature.                */
void check_sig(q)
NODE *q;
{
    register NODE *p = q;

    if (p == NIL) return;
    while (   (p -> kind == LETTERID || p -> kind == OPRID)
	   && p -> sel_type == NIL
	   && p -> id_last_definition != NIL
	   && p -> id_last_definition -> kind == DECLARATION
	   && p -> id_last_definition -> decl_sig_transp
	   && p -> id_last_definition -> post_num < p -> post_num) {
	    p = p -> id_last_definition -> decl_denotation;
    }
    switch (p -> kind) {
	case SIGNATURESIG:
	case VALSIGNATURE:
	case VARSIGNATURE:
	case FUNCSIGNATURE:
	case TYPESIGNATURE:
	    break;
	default:
	    if (p -> kind == LETTERID || p -> kind == OPRID) {
		if ( p -> id_last_definition == NIL
		     || p -> id_last_definition -> kind != PARAMETER
		     || comp_st(p -> id_last_definition -> par_signature,
				sig_Signature, NIL, NIL) != 0) {
		  errmsg1(q,
			  "Identifier %s not meaningfully bound to a signature",
			  getname(q -> id_str_table_index));
		}
	    } else {
		errmsg0(q, "Signature expected");
	    }
    }
}
#DJDSTART
